/**/
call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs

call RxFuncAdd 'SockLoadFuncs','rxSock','SockLoadFuncs'
call SockLoadFuncs

call RxFuncAdd 'mciRxInit','MCIAPI','mciRxInit'
call mciRxInit
'@echo off'
ini_fname='cddb.ini' /*host_name_or_address:port*/
progName='OS/2_rexxCDDB'
progVendor='Stalker'
VendorHost='os2.ru'
progVersion='1.21'
arguments=arg(1)
argumentValue=''

defaultHost='cddb.cddb.com'
defaultPort=8880
debug=0

if isArg('/DEBUG') then	debug=1

errors.0=7
errors.1="Error quering CD info"
errors.2="Not audio CD"
errors.3="Socket error"
errors.4="Error quering disc ID"
errors.5="Error quering disc ID"
errors.6="Error connecting to host"
errors.7="Incomplete record(s) found. Please use '-SEL:x' option"
errors.255="Aborted"

errorNum=0
signal on halt name error


errorNum=1
parse value SendString('open cdaudio01 alias dev_cd shareable wait') with rc ':' st
if rc<>0 then signal error

parse value SendString('set dev_cd time format milliseconds wait') with rc ':' st
if rc<>0 then signal error

parse value SendString('status dev_cd length wait') with rc ':' cd_totalTime
if rc<>0 then signal error
cd_totalTime=cd_totalTime%1000

parse value SendString('set dev_cd time format MMTIME wait') with rc ':' st
if rc<>0 then signal error

parse value SendString('status dev_cd number of tracks wait') with rc ':' tracks.0
if rc<>0 then signal error

do i=1 to tracks.0
	parse value SendString('status dev_cd position track '||i||' wait') with rc ':' tracks.i
	if rc<>0 then signal error
	tracks.i=tracks.i/40
end
call SendString 'close dev_cd wait'
errorNum=2
if tracks.0=0 then signal error
/*end quering CD*/

fl=0
err=1
endstring=X2C('D')||X2C('A')
do while(lines(ini_fname)>0) | (fl=0) 
	st=strip(linein(ini_fname))
	parse value st with hostName ':' hostPort
	hostName=strip(hostName)
	hostPort=strip(hostPort)
	if length(hostName)=0 then hostName=defaultHost
	if length(hostPort)=0 then hostPort=defaultPort
	addr.addr=checkHN(hostName)
	if length(addr.addr)>0 then do
		addr.port = hostPort
		addr.family = AF_INET
		sock=SockSocket(AF_INET,SOCK_STREAM,0)
		errorNum=3
		if sock=-1 then signal error

		say 'Connecting to: '||addr.addr||':'||addr.port

		rc=SockConnect(sock,"addr.")
		if rc>-1 then do

			say 'Connected: OK'
	
			st=TCPRecieve(sock)
			say st
	

			out_st=tracks.0
			do i=1 to tracks.0
				out_st=out_st||' '||tracks.i
			end
			out_st=out_st||' '||cd_totalTime
			call TCPSend sock,'discid '||out_st

			disk_id=TCPRecieve(sock)
			parse value disk_id with '200 Disc ID is ' disk_id 
			disk_id=strip(disk_id)
			errorNum=4
			if length(disk_id)=0 then signal error
			call TCPSend sock,'cddb hello '||progVendor||' '||VendorHost||' '||progName||' '||progVersion
			st=TCPRecieve(sock)
			say st

			out_st2='cddb query '||disk_id||' '||out_st
			if debug=1 then do 
				say '(DEBUG)QUERY STRING: '||out_st2
				if isArg('-QUERY') then do
					out_st2=argumentValue
				end
			end
			call TCPSend sock,out_st2
			st=TCPRecieve(sock,1)
			errorNum=5
			rc=substr(st,1,3)
			if rc='211' then do
				errorNum=7
				multitrack.0=0
				i=0
				do while(length(st)>0)
					
					m=pos(endstring,st)
					if m>0 then do
						query_string=substr(st,1,m-1)
						st=delstr(st,1,m+1)
						if ((substr(query_string,1,3)<>'211') & (query_string<>'.')) then do
							i=multitrack.0+1
							multitrack.i=query_string
							multitrack.0=i
						end
					end
					else do	
						st=''
					end
				end
				do i=1 to multitrack.0
					say i||') '||multitrack.i
				end
				if isArg('-SEL') then do
					if dataType(argumentValue,'N')<>1 then signal error
					argumentValue=argumentValue%1
					if ((argumentValue<1) | (argumentValue>multitrack.0)) then signal error
					rc='200'
					st='200 '||multitrack.argumentValue
				end
				else do
					signal error
				end
			end
			errorNum=5
			if rc<>'200' then signal error
			st=strip(translate(st,'  ',endstring))		
			say st
			parse value st with '200 ' genre disk_id group '/' albom
			genre=strip(genre)
			albom=strip(albom)
			group=strip(group)
			say 'Genre: '||genre
			say 'Albom: '||albom
			say 'Group: '||group
			call TCPSend sock,'cddb read '||genre||' '||disk_id
			st=TCPRecieve(sock,1)
			st=st||TCPRecieve(sock,1)
			do while(length(st)>0)
				i=pos(endstring,st)
				if i>0 then do
					query_string=substr(st,1,i-1)
					st=delstr(st,1,i+1)
					if (substr(query_string,1,6)='TTITLE') then do
						tnumber=delstr(query_string,1,6)
						parse value tnumber with tnumber '=' tname 
						tnumber=tnumber+1
						m=length(tname)
						tracks.tnumber.name=strip(tname)
					end
				end
				else do
					st=''
				end
			end
			do i=1 to tracks.0
				say 'Track '||i||': '||tracks.i.name
			end
			call TCPSend sock,'quit'
			call SockSoClose(sock)
			err=0
		end
	end
	fl=1
	if err=0 then leave	
end

call stream ini_fname,'c','close'
if err=1 then do
	errorNum=6
	signal Error
end
else do
	if isArg('-REN') then do
		search_pattern=strip(ArgumentValue)
		if length(search_pattern)>0 then do
			call sysFileTree search_Pattern||'*.mp3',stem,'FO'
			do i=1 to stem.0
				parse value stem.i with string(search_Pattern) t_char '.mp3'
				t_char=strip(t_char,'B','.')
				t_num=c2d(t_char)-64
				'ren "'||stem.i||'" "'||tracks.t_num.name||'.'||t_char||'.mp3"'
			end
		end
	end
end
exit
error:
	call showError
	exit

TCPSend: procedure expose errors.
	parse arg socket, st
	rc=SockSend(socket,st||X2C('A'))
return rc

CheckHN: procedure expose errors.
	parse arg hostname
	parse value hostname with net_A '.' net_B '.' net_C '.' net_D
	
	if length(net_D)=0 then do
		ns_query.addr=''
		call SockGetHostByName hostname,'ns_query.'
		rc=ns_query.addr
	end
	else do
		rc=hostname
	end
return rc

TCPRecieve: procedure expose errors.
	parse arg socket,notr
	rc=SockRecv(socket,st,80*40)
	if rc>-1 then do
		if length(notr)=0 then do
			st=strip(translate(st,'  ',X2C('A')||X2C('D')))
		end
		else do
			st=strip(st)
		end
	end
	else do
		st=''
	end
return st

SendString: procedure expose errors.
	arg CmndTxt
	rc = mciRxSendString(CmndTxt, 'st', '0', '0')
	rc=rc||':'||st
return rc

string:procedure 
	parse arg st
return st

showError: procedure expose errorNum errors. 
	if (errorNum<0) | (errorNum>255) then errorNum=255
	errName='CDDB'||Right(errorNum,4,'0')
	
	if (errorNum>errors.0) & (errorNum<>255) then do
		say errName
		say "CDDB0255: error message not defined"
		exit
	end
	else do
		if errorNum>0 then say errName||": "||errors.errorNum
	end
return

isArg:procedure expose arguments argumentValue
	parse arg option
	option=translate(option)
	opt_spos=pos(option,translate(arguments))
	if (opt_spos>0) then do
		fl=0
		quote=0
		val_st=0
		opt_epos=opt_spos
		do while ((fl=0) & (opt_epos<length(arguments)+1))
			opt_epos=opt_epos+1
			ch=substr(arguments,opt_epos,1)
			select
				when (ch='"') | (ch="'") then do
					quote=quote+1
					if quote>1 then quote=0
				end
				when (ch=' ') then do
					if quote=0 then fl=1
				end
				when (ch=':') | (ch='=') then do
					if (quote=0) & (val_st=0) then do
						val_st=opt_epos
					end
				end
				otherwise
			end
		end
		argumentValue=''
		if val_st>0 then do
			argumentValue=substr(arguments,val_st+1,opt_epos-val_st-1)
			argumentValue=strip(argumentValue,'B','"')
			argumentValue=strip(argumentValue,'B',"'")
			arguments=delstr(arguments,val_st,opt_epos-val_st+1)
		end
		rc=1 
	end
	else do
		rc=0
	end
	if rc=1 then 
		arguments=strip(delstr(arguments,pos(option,translate(arguments)),length(option)))
return rc
